package com.perforce.hws.core.p4base;

/**
 * Created by tjuricek on 11/30/15.
 */
public class P4BaseException extends RuntimeException {

    private ResultMap resultMap;

    public P4BaseException(ResultMap resultMap) {
        super();
        this.resultMap = resultMap;
        // We may want to attempt to format the message in any "fmtX" key
    }

    public P4BaseException(ResultMap resultMap, String message) {
        super(message);
        this.resultMap = resultMap;
    }

    public P4BaseException(ResultMap resultMap, String message, Throwable cause) {
        super(message, cause);
        this.resultMap = resultMap;
    }

    public P4BaseException(ResultMap resultMap, Throwable cause) {
        super(cause);
        this.resultMap = resultMap;
    }

    protected P4BaseException(ResultMap resultMap, String message, Throwable cause, boolean enableSuppression, boolean writableStackTrace) {
        super(message, cause, enableSuppression, writableStackTrace);
        this.resultMap = resultMap;
    }

    public ResultMap getResultMap() {
        return resultMap;
    }
}